
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module DE1_SoC_467Base(

	//////////// CLOCK //////////
	input 		          		CLOCK_50,
	input 		          		CLOCK2_50,
	input 		          		CLOCK3_50,
	input 		          		CLOCK4_50,

	//////////// SDRAM //////////
	output		    [12:0]		DRAM_ADDR,
	output		     [1:0]		DRAM_BA,
	output		          		DRAM_CAS_N,
	output		          		DRAM_CKE,
	output		          		DRAM_CLK,
	output		          		DRAM_CS_N,
	inout 		    [15:0]		DRAM_DQ,
	output		          		DRAM_LDQM,
	output		          		DRAM_RAS_N,
	output		          		DRAM_UDQM,
	output		          		DRAM_WE_N,

	//////////// SEG7 //////////
	output		     [6:0]		HEX0,
	output		     [6:0]		HEX1,
	output		     [6:0]		HEX2,
	output		     [6:0]		HEX3,
	output		     [6:0]		HEX4,
	output		     [6:0]		HEX5,

	//////////// KEY //////////
	input 		     [3:0]		KEY,

	//////////// LED //////////
	output		     [9:0]		LEDR,

	//////////// HPS //////////
	inout 		          		HPS_CONV_USB_N,
	output		    [14:0]		HPS_DDR3_ADDR,
	output		     [2:0]		HPS_DDR3_BA,
	output		          		HPS_DDR3_CAS_N,
	output		          		HPS_DDR3_CK_N,
	output		          		HPS_DDR3_CK_P,
	output		          		HPS_DDR3_CKE,
	output		          		HPS_DDR3_CS_N,
	output		     [3:0]		HPS_DDR3_DM,
	inout 		    [31:0]		HPS_DDR3_DQ,
	inout 		     [3:0]		HPS_DDR3_DQS_N,
	inout 		     [3:0]		HPS_DDR3_DQS_P,
	output		          		HPS_DDR3_ODT,
	output		          		HPS_DDR3_RAS_N,
	output		          		HPS_DDR3_RESET_N,
	input 		          		HPS_DDR3_RZQ,
	output		          		HPS_DDR3_WE_N,
	output		          		HPS_ENET_GTX_CLK,
	inout 		          		HPS_ENET_INT_N,
	output		          		HPS_ENET_MDC,
	inout 		          		HPS_ENET_MDIO,
	input 		          		HPS_ENET_RX_CLK,
	input 		     [3:0]		HPS_ENET_RX_DATA,
	input 		          		HPS_ENET_RX_DV,
	output		     [3:0]		HPS_ENET_TX_DATA,
	output		          		HPS_ENET_TX_EN,
	inout 		     [3:0]		HPS_FLASH_DATA,
	output		          		HPS_FLASH_DCLK,
	output		          		HPS_FLASH_NCSO,
	inout 		     [1:0]		HPS_GPIO,
	inout 		          		HPS_GSENSOR_INT,
	inout 		          		HPS_I2C_CONTROL,
	inout 		          		HPS_I2C1_SCLK,
	inout 		          		HPS_I2C1_SDAT,
	inout 		          		HPS_I2C2_SCLK,
	inout 		          		HPS_I2C2_SDAT,
	inout 		          		HPS_KEY,
	inout 		          		HPS_LED,
	output		          		HPS_SD_CLK,
	inout 		          		HPS_SD_CMD,
	inout 		     [3:0]		HPS_SD_DATA,
	output		          		HPS_SPIM_CLK,
	input 		          		HPS_SPIM_MISO,
	output		          		HPS_SPIM_MOSI,
	inout 		          		HPS_SPIM_SS,
	input 		          		HPS_UART_RX,
	output		          		HPS_UART_TX,
	input 		          		HPS_USB_CLKOUT, 	
	inout 		     [7:0]		HPS_USB_DATA,
	input 		          		HPS_USB_DIR,
	input 		          		HPS_USB_NXT,
	output		          		HPS_USB_STP,

	//////////// VGA //////////
	output		     [7:0]		VGA_B,
	output		          		VGA_BLANK_N,
	output		          		VGA_CLK,
	output		     [7:0]		VGA_G,
	output		          		VGA_HS,
	output		     [7:0]		VGA_R,
	output		          		VGA_SYNC_N,
	output		          		VGA_VS
);

//=======================================================
//  Instantiate your Qsys SoC system here
//=======================================================

wire fifo_in_read;
wire [31:0] fifo_in_readdata;
wire fifo_in_wait;
wire fifo_out_write;
wire [31:0] fifo_out_writedata;
wire fifo_out_wait;

wire reset_n = KEY[1];	// 0 = pressed

wire [1:0] DRAM_DQM;
assign DRAM_LDQM = DRAM_DQM[0];
assign DRAM_UDQM = DRAM_DQM[1];

wire [24:0] sdram_address;     
wire [1:0]  sdram_byteenable_n;  
wire [15:0] sdram_writedata;
wire        sdram_read_n;
wire			sdram_write_n;
wire			sdram_chipselect;
wire [15:0]	sdram_readdata;
wire			sdram_readdatavalid;
wire        sdram_waitrequest;

SoC467Base qsys_soc (

	// Clocks and reset
	.clk_clk( CLOCK_50 ),
	.reset_reset_n(reset_n),
	
	// FIFOs to/from the HPS
	.fifo_h2f_out_read(fifo_in_read),
	.fifo_h2f_out_readdata(fifo_in_readdata),
	.fifo_h2f_out_waitrequest(fifo_in_wait),
	.fifo_f2h_in_write(fifo_out_write),
	.fifo_f2h_in_writedata(fifo_out_writedata),
	.fifo_f2h_in_waitrequest(fifo_out_wait),

	// SDRAM Pins
	.sdram_controller_0_wire_addr(DRAM_ADDR),
	.sdram_controller_0_wire_ba(DRAM_BA),
	.sdram_controller_0_wire_cas_n(DRAM_CAS_N),
	.sdram_controller_0_wire_cke(DRAM_CKE),
	.sdram_controller_0_wire_cs_n(DRAM_CS_N),
	.sdram_controller_0_wire_dq(DRAM_DQ),
	.sdram_controller_0_wire_dqm(DRAM_DQM),
	.sdram_controller_0_wire_ras_n(DRAM_RAS_N),
	.sdram_controller_0_wire_we_n(DRAM_WE_N),
	.dram_clk_pll_outclk0_clk(DRAM_CLK),
	
	// SDRAM Avalon-MM-Master interface
	.sdram_controller_0_s1_address(sdram_address),
	.sdram_controller_0_s1_byteenable_n(sdram_byteenable_n),
	.sdram_controller_0_s1_chipselect(sdram_chipselect),
	.sdram_controller_0_s1_writedata(sdram_writedata),
	.sdram_controller_0_s1_read_n(sdram_read_n),
	.sdram_controller_0_s1_write_n(sdram_write_n),
	.sdram_controller_0_s1_readdata(sdram_readdata),
	.sdram_controller_0_s1_readdatavalid(sdram_readdatavalid),
	.sdram_controller_0_s1_waitrequest(sdram_waitrequest),

	.memory_mem_a                          ( HPS_DDR3_ADDR),                          //          memory.mem_a
	.memory_mem_ba                         ( HPS_DDR3_BA),                         //                .mem_ba
	.memory_mem_ck                         ( HPS_DDR3_CK_P),                         //                .mem_ck
	.memory_mem_ck_n                       ( HPS_DDR3_CK_N),                       //                .mem_ck_n
	.memory_mem_cke                        ( HPS_DDR3_CKE),                        //                .mem_cke
	.memory_mem_cs_n                       ( HPS_DDR3_CS_N),                       //                .mem_cs_n
	.memory_mem_ras_n                      ( HPS_DDR3_RAS_N),                      //                .mem_ras_n
	.memory_mem_cas_n                      ( HPS_DDR3_CAS_N),                      //                .mem_cas_n
	.memory_mem_we_n                       ( HPS_DDR3_WE_N),                       //                .mem_we_n
	.memory_mem_reset_n                    ( HPS_DDR3_RESET_N),                    //                .mem_reset_n
	.memory_mem_dq                         ( HPS_DDR3_DQ),                         //                .mem_dq
	.memory_mem_dqs                        ( HPS_DDR3_DQS_P),                        //                .mem_dqs
	.memory_mem_dqs_n                      ( HPS_DDR3_DQS_N),                      //                .mem_dqs_n
	.memory_mem_odt                        ( HPS_DDR3_ODT),                        //                .mem_odt
	.memory_mem_dm                         ( HPS_DDR3_DM),                         //                .mem_dm
	.memory_oct_rzqin                      ( HPS_DDR3_RZQ)                      //                .oct_rzqin
);

reg [31:0]  clk_counter;
reg [4:0]	key_samples;
reg [23:0]	heart_beat;

always@(posedge CLOCK_50)
begin
	clk_counter <= (clk_counter == 32'd4_000_001) ? 32'd0 : clk_counter + 1'b1;
	heart_beat <= heart_beat + 1;
	if (clk_counter == 32'd4_000_000)
		key_samples[4:0] = {key_samples[3:0],KEY[0]};
end


reg[2:0]	cmd_state;	// main state machine

parameter cmd_state_empty = 3'b000;
parameter cmd_state_reading = 3'b001;
parameter cmd_state_process = 3'b010;
parameter cmd_state_write_hps = 3'b011;
parameter cmd_state_write_sdram = 3'b100;
parameter cmd_state_read_sdram = 3'b101;

reg[31:0]		cmd_input_data;
reg[31:0]		write_back_data;
reg[24:0]		sdram_cmd_address;

assign sdram_address = sdram_cmd_address;
assign sdram_writedata[15:0] = cmd_input_data[15:0];

assign LEDR[2] = heart_beat[22];

parameter fifo_input_ready = 1'b0;
parameter fifo_input_not_ready = 1'b1;
parameter fifo_output_ready = 1'b0;
parameter fifo_output_not_ready = 1'b1;
parameter fifo_will_read_data = 1'b1;
parameter fifo_will_not_read_data = 1'b0;
parameter fifo_will_write_data = 1'b1;
parameter fifo_will_not_write_data = 1'b0;

parameter data_available = 1'b0;
parameter data_not_available = 1'b1;

assign fifo_in_read = (cmd_state == cmd_state_empty && fifo_in_wait == fifo_input_ready) ?
	fifo_will_read_data : fifo_will_not_read_data;

assign fifo_out_write = (cmd_state == cmd_state_write_hps && fifo_out_wait == fifo_output_ready) ?
	fifo_will_write_data : fifo_will_not_write_data;

assign fifo_out_writedata = write_back_data;

parameter cmd_echo= 4'b0000;
parameter cmd_setaddress = 4'b0001;
parameter cmd_write = 4'b0010;
parameter cmd_read = 4'b0011;

assign sdram_byteenable_n = 2'b00;
assign sdram_read_n = (cmd_state == cmd_state_read_sdram) ? 1'b0 : 1'b1;
assign sdram_write_n = (cmd_state == cmd_state_write_sdram) ? 1'b0 : 1'b1;
assign sdram_chipselect = (sdram_read_n == 1'b0 || sdram_write_n == 1'b0) ? 1'b1 : 1'b0;

// Simple state machine that reflects data from the input to the output
always @(posedge CLOCK_50)
	begin
		if (!reset_n)
			begin
				cmd_state <= cmd_state_empty;
				write_back_data <= 32'd0;
			end
		else
		begin
		case (cmd_state)
			cmd_state_empty:
				// Is there something in the input fifo?
				// if so, move to the reading state.
				if (fifo_in_wait == fifo_input_ready)
					cmd_state <= cmd_state_reading;
			cmd_state_reading:
				// read the input fifo and transition into the try
				// to write state
				begin
					cmd_input_data <= fifo_in_readdata;
					cmd_state <= cmd_state_process;
				end
			cmd_state_process:
				// Figure out what the command is
				case (cmd_input_data[31:28])
					cmd_echo:
						begin
							write_back_data <= { 16'b0000_0000_0000_0000, cmd_input_data[15:0] };
							cmd_state <= cmd_state_write_hps;
						end
					cmd_setaddress:
						begin
							sdram_cmd_address <= cmd_input_data[24:0];
							cmd_state <= cmd_state_empty;
						end	
					cmd_write:
							cmd_state <= cmd_state_write_sdram;
					cmd_read:
							cmd_state <= cmd_state_read_sdram;
					endcase
			cmd_state_write_sdram:
				begin
				if (!sdram_waitrequest)
					cmd_state <= cmd_state_empty;
				end
			cmd_state_read_sdram:
				begin
				if (!sdram_waitrequest && sdram_readdatavalid)
					begin
						write_back_data <= { 16'b0000_0000_0000_0000, sdram_readdata };
						cmd_state <= cmd_state_write_hps;
					end
				end
			cmd_state_write_hps:
				if (fifo_out_wait == fifo_output_ready)
					cmd_state <= cmd_state_empty;
		endcase
		end // reset
end

endmodule
