	component SoC467Base is
		port (
			clk_clk                             : in    std_logic                     := 'X';             -- clk
			memory_mem_a                        : out   std_logic_vector(12 downto 0);                    -- mem_a
			memory_mem_ba                       : out   std_logic_vector(2 downto 0);                     -- mem_ba
			memory_mem_ck                       : out   std_logic;                                        -- mem_ck
			memory_mem_ck_n                     : out   std_logic;                                        -- mem_ck_n
			memory_mem_cke                      : out   std_logic;                                        -- mem_cke
			memory_mem_cs_n                     : out   std_logic;                                        -- mem_cs_n
			memory_mem_ras_n                    : out   std_logic;                                        -- mem_ras_n
			memory_mem_cas_n                    : out   std_logic;                                        -- mem_cas_n
			memory_mem_we_n                     : out   std_logic;                                        -- mem_we_n
			memory_mem_reset_n                  : out   std_logic;                                        -- mem_reset_n
			memory_mem_dq                       : inout std_logic_vector(31 downto 0) := (others => 'X'); -- mem_dq
			memory_mem_dqs                      : inout std_logic_vector(3 downto 0)  := (others => 'X'); -- mem_dqs
			memory_mem_dqs_n                    : inout std_logic_vector(3 downto 0)  := (others => 'X'); -- mem_dqs_n
			memory_mem_odt                      : out   std_logic;                                        -- mem_odt
			memory_mem_dm                       : out   std_logic_vector(3 downto 0);                     -- mem_dm
			memory_oct_rzqin                    : in    std_logic                     := 'X';             -- oct_rzqin
			sdram_controller_0_s1_address       : in    std_logic_vector(24 downto 0) := (others => 'X'); -- address
			sdram_controller_0_s1_byteenable_n  : in    std_logic_vector(1 downto 0)  := (others => 'X'); -- byteenable_n
			sdram_controller_0_s1_chipselect    : in    std_logic                     := 'X';             -- chipselect
			sdram_controller_0_s1_writedata     : in    std_logic_vector(15 downto 0) := (others => 'X'); -- writedata
			sdram_controller_0_s1_read_n        : in    std_logic                     := 'X';             -- read_n
			sdram_controller_0_s1_write_n       : in    std_logic                     := 'X';             -- write_n
			sdram_controller_0_s1_readdata      : out   std_logic_vector(15 downto 0);                    -- readdata
			sdram_controller_0_s1_readdatavalid : out   std_logic;                                        -- readdatavalid
			sdram_controller_0_s1_waitrequest   : out   std_logic;                                        -- waitrequest
			fifo_h2f_out_readdata               : out   std_logic_vector(31 downto 0);                    -- readdata
			fifo_h2f_out_read                   : in    std_logic                     := 'X';             -- read
			fifo_h2f_out_waitrequest            : out   std_logic;                                        -- waitrequest
			fifo_f2h_in_writedata               : in    std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			fifo_f2h_in_write                   : in    std_logic                     := 'X';             -- write
			fifo_f2h_in_waitrequest             : out   std_logic;                                        -- waitrequest
			reset_reset_n                       : in    std_logic                     := 'X';             -- reset_n
			sdram_controller_0_wire_addr        : out   std_logic_vector(12 downto 0);                    -- addr
			sdram_controller_0_wire_ba          : out   std_logic_vector(1 downto 0);                     -- ba
			sdram_controller_0_wire_cas_n       : out   std_logic;                                        -- cas_n
			sdram_controller_0_wire_cke         : out   std_logic;                                        -- cke
			sdram_controller_0_wire_cs_n        : out   std_logic;                                        -- cs_n
			sdram_controller_0_wire_dq          : inout std_logic_vector(15 downto 0) := (others => 'X'); -- dq
			sdram_controller_0_wire_dqm         : out   std_logic_vector(1 downto 0);                     -- dqm
			sdram_controller_0_wire_ras_n       : out   std_logic;                                        -- ras_n
			sdram_controller_0_wire_we_n        : out   std_logic;                                        -- we_n
			dram_clk_pll_outclk0_clk            : out   std_logic                                         -- clk
		);
	end component SoC467Base;

	u0 : component SoC467Base
		port map (
			clk_clk                             => CONNECTED_TO_clk_clk,                             --                     clk.clk
			memory_mem_a                        => CONNECTED_TO_memory_mem_a,                        --                  memory.mem_a
			memory_mem_ba                       => CONNECTED_TO_memory_mem_ba,                       --                        .mem_ba
			memory_mem_ck                       => CONNECTED_TO_memory_mem_ck,                       --                        .mem_ck
			memory_mem_ck_n                     => CONNECTED_TO_memory_mem_ck_n,                     --                        .mem_ck_n
			memory_mem_cke                      => CONNECTED_TO_memory_mem_cke,                      --                        .mem_cke
			memory_mem_cs_n                     => CONNECTED_TO_memory_mem_cs_n,                     --                        .mem_cs_n
			memory_mem_ras_n                    => CONNECTED_TO_memory_mem_ras_n,                    --                        .mem_ras_n
			memory_mem_cas_n                    => CONNECTED_TO_memory_mem_cas_n,                    --                        .mem_cas_n
			memory_mem_we_n                     => CONNECTED_TO_memory_mem_we_n,                     --                        .mem_we_n
			memory_mem_reset_n                  => CONNECTED_TO_memory_mem_reset_n,                  --                        .mem_reset_n
			memory_mem_dq                       => CONNECTED_TO_memory_mem_dq,                       --                        .mem_dq
			memory_mem_dqs                      => CONNECTED_TO_memory_mem_dqs,                      --                        .mem_dqs
			memory_mem_dqs_n                    => CONNECTED_TO_memory_mem_dqs_n,                    --                        .mem_dqs_n
			memory_mem_odt                      => CONNECTED_TO_memory_mem_odt,                      --                        .mem_odt
			memory_mem_dm                       => CONNECTED_TO_memory_mem_dm,                       --                        .mem_dm
			memory_oct_rzqin                    => CONNECTED_TO_memory_oct_rzqin,                    --                        .oct_rzqin
			sdram_controller_0_s1_address       => CONNECTED_TO_sdram_controller_0_s1_address,       --   sdram_controller_0_s1.address
			sdram_controller_0_s1_byteenable_n  => CONNECTED_TO_sdram_controller_0_s1_byteenable_n,  --                        .byteenable_n
			sdram_controller_0_s1_chipselect    => CONNECTED_TO_sdram_controller_0_s1_chipselect,    --                        .chipselect
			sdram_controller_0_s1_writedata     => CONNECTED_TO_sdram_controller_0_s1_writedata,     --                        .writedata
			sdram_controller_0_s1_read_n        => CONNECTED_TO_sdram_controller_0_s1_read_n,        --                        .read_n
			sdram_controller_0_s1_write_n       => CONNECTED_TO_sdram_controller_0_s1_write_n,       --                        .write_n
			sdram_controller_0_s1_readdata      => CONNECTED_TO_sdram_controller_0_s1_readdata,      --                        .readdata
			sdram_controller_0_s1_readdatavalid => CONNECTED_TO_sdram_controller_0_s1_readdatavalid, --                        .readdatavalid
			sdram_controller_0_s1_waitrequest   => CONNECTED_TO_sdram_controller_0_s1_waitrequest,   --                        .waitrequest
			fifo_h2f_out_readdata               => CONNECTED_TO_fifo_h2f_out_readdata,               --            fifo_h2f_out.readdata
			fifo_h2f_out_read                   => CONNECTED_TO_fifo_h2f_out_read,                   --                        .read
			fifo_h2f_out_waitrequest            => CONNECTED_TO_fifo_h2f_out_waitrequest,            --                        .waitrequest
			fifo_f2h_in_writedata               => CONNECTED_TO_fifo_f2h_in_writedata,               --             fifo_f2h_in.writedata
			fifo_f2h_in_write                   => CONNECTED_TO_fifo_f2h_in_write,                   --                        .write
			fifo_f2h_in_waitrequest             => CONNECTED_TO_fifo_f2h_in_waitrequest,             --                        .waitrequest
			reset_reset_n                       => CONNECTED_TO_reset_reset_n,                       --                   reset.reset_n
			sdram_controller_0_wire_addr        => CONNECTED_TO_sdram_controller_0_wire_addr,        -- sdram_controller_0_wire.addr
			sdram_controller_0_wire_ba          => CONNECTED_TO_sdram_controller_0_wire_ba,          --                        .ba
			sdram_controller_0_wire_cas_n       => CONNECTED_TO_sdram_controller_0_wire_cas_n,       --                        .cas_n
			sdram_controller_0_wire_cke         => CONNECTED_TO_sdram_controller_0_wire_cke,         --                        .cke
			sdram_controller_0_wire_cs_n        => CONNECTED_TO_sdram_controller_0_wire_cs_n,        --                        .cs_n
			sdram_controller_0_wire_dq          => CONNECTED_TO_sdram_controller_0_wire_dq,          --                        .dq
			sdram_controller_0_wire_dqm         => CONNECTED_TO_sdram_controller_0_wire_dqm,         --                        .dqm
			sdram_controller_0_wire_ras_n       => CONNECTED_TO_sdram_controller_0_wire_ras_n,       --                        .ras_n
			sdram_controller_0_wire_we_n        => CONNECTED_TO_sdram_controller_0_wire_we_n,        --                        .we_n
			dram_clk_pll_outclk0_clk            => CONNECTED_TO_dram_clk_pll_outclk0_clk             --    dram_clk_pll_outclk0.clk
		);

